=== debian/changelog ===
qpid-proton (0.22.0-5.1ubuntu2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 17 Mar 2022 20:10:56 +0000

qpid-proton (0.22.0-5.1ubuntu1) jammy; urgency=medium

  * d/rules: add -Wno-error=deprecated-declarations to CFLAGS to fix
    the build against OpenSSL 3.0

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 07 Dec 2021 18:23:21 +0100

qpid-proton (0.22.0-5.1build2) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Mon, 29 Nov 2021 13:48:49 +0100

qpid-proton (0.22.0-5.1build1) jammy; urgency=medium

  * No-change rebuild to add python3.10.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 16 Oct 2021 06:59:34 +0000

qpid-proton (0.22.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Removing python2 autopkg test. Closes: #974097 

 -- Bernd Zeimetz <bzed@debian.org>  Sat, 26 Dec 2020 12:37:11 +0100

qpid-proton (0.22.0-5) unstable; urgency=medium

  * Re-upload source-only.

 -- Thomas Goirand <zigo@debian.org>  Fri, 16 Oct 2020 13:55:17 +0200

qpid-proton (0.22.0-4) unstable; urgency=medium

  * Remove Daniel Pocock and Darryl L. Pierce from uploaders.
  * Ran wrap-and-sort -bastk.
  * Switched to debhelper-compat =10 instead of d/compat.
  * ACK previous uploads:
    - Drop Python 2 support and stop building the doc with epydoc, which is now
      removed from Debian.
    - Remove epydoc build-depends.
  * Reintroduce python-qpid-proton-doc package, this time using sphinx.

 -- Thomas Goirand <zigo@debian.org>  Mon, 09 Mar 2020 12:03:23 +0100

qpid-proton (0.22.0-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop python2 support; Closes: #938313

 -- Sandro Tosi <morph@debian.org>  Thu, 02 Jan 2020 22:49:44 -0500

qpid-proton (0.22.0-3.2) unstable; urgency=medium

  * Replace previous NMU with a new source-only upload.

 -- Kenneth J. Pronovici <pronovic@debian.org>  Thu, 08 Aug 2019 02:29:46 +0000

qpid-proton (0.22.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Eliminate dependency on epydoc, which will be removed (closes: #881561)
    - Update debian/control to remove Build-Depends: python-epydoc
    - Update debian/control to remove now-empty python-qpid-proton-doc package
    - Remove debian/python-qpid-proton-doc.install

 -- Kenneth J. Pronovici <pronovic@debian.org>  Fri, 02 Aug 2019 17:54:46 +0000

qpid-proton (0.22.0-3) unstable; urgency=medium

  * Using https for debian/watch.
  * List Barclays and others in debian/copyright (Closes: #896117).
  * Remove examples/c/include from d/copyright (gone from current upstream
    sources).
  * Using https in d/copyright Source, and d/control Homepage fields.
  * Various other fixes for d/copyright.
  * Add breaks+replaces for old versions, and fix doc symlinks as per advice
    from Adrian Bunk (Closes: #896507).
  * Fix build issue with GCC by applying upstream patch (Closes: #897841).
  * Point VCS URLs to Salsa.

 -- Thomas Goirand <zigo@debian.org>  Mon, 07 Jan 2019 17:16:42 +0100

qpid-proton (0.22.0-2) unstable; urgency=high

  * Fix i386 build issue by using DEB_BUILD_GNU_TYPE instead of
    DEB_TARGET_MULTIARCH.

 -- Daniel Pocock <daniel@pocock.pro>  Fri, 20 Apr 2018 10:00:34 +0100

qpid-proton (0.22.0-1) unstable; urgency=high

  * New upstream release.
  * Built against OpenSSL 1.1.  (Closes: #859669)
  * Patch to avoid mismatch with hardening flags.  (Closes: #871087)
  * Rebuilt with GCC 7.  (Closes: #871292)

 -- Daniel Pocock <daniel@pocock.pro>  Tue, 17 Apr 2018 10:39:22 +0200
