=== debian/watch ===
version=3
https://www.apache.org/dist/qpid/proton/([\.\d]+)/qpid-proton-(.*)\.tar\.gz
